"""Autogenerated file: DO NOT EDIT!"""
import typing  # noqa: F401
from dazzler.system import Component, Aspect, UNDEFINED  # noqa: F401


class ListBox(Component):
    """
    A component where you can ``add`` items to instead of rendering
    the whole list again. With an optional max size.

    :CSS:

        - ``dazzler-core-list-box``
        - ``vertical``
        - ``horizontal``
        - ``scrollable``

    :example:

    .. literalinclude:: ../../tests/components/pages/list_box.py
    """
    items = Aspect(default=UNDEFINED, children=True, docstring="List of items to render. (default=[])")  # noqa: E501
    max_length = Aspect(docstring="Maximum amount of items in the list, extra items will be popped off.")  # noqa: E501
    append = Aspect(children=True, docstring="Add an item to the end of the list.")  # noqa: E501
    prepend = Aspect(children=True, docstring="Add an item to the start of the list.")  # noqa: E501
    concat = Aspect(children=True, docstring="Concatenate another list with the current items.")  # noqa: E501
    insert = Aspect(children=True, docstring="Insert an item at an index position.")  # noqa: E501
    delete_index = Aspect(docstring="Delete the item at the index.")
    scrollable = Aspect(docstring="Wether the list box container is scrollable.Set the overflow content to scroll.")  # noqa: E501
    direction = Aspect(default="'vertical'", docstring="In which direction the items will be inserted. (Possible values: 'vertical', 'horizontal') (default="'vertical'")")  # noqa: E501
    size = Aspect(docstring="Must be set for the scrollable aspect to work.Height or width in pixels depending on the direction aspect.")  # noqa: E501
    keep_scroll = Aspect(docstring="Keep the last appended item in view if scrolling is enabled.")  # noqa: E501
    color = Aspect(docstring="Font color")
    background = Aspect(docstring="Background color/image")
    padding = Aspect(docstring="Space around the content before the border")
    margin = Aspect(docstring="Space after the element border")
    overflow = Aspect(docstring="Overflow the content and show a scrollbar.")
    height = Aspect(docstring="Height of the component.")
    max_height = Aspect(docstring="Maximum height before overflow.")
    width = Aspect(docstring="Width of the component.")
    max_width = Aspect(docstring="Maximum width before overflowing.")
    font_family = Aspect(docstring="Font to use.")
    font_size = Aspect(docstring="Size of the font.")
    font_weight = Aspect(docstring="Boldness")
    font_style = Aspect(docstring="Italic")
    text_align = Aspect(docstring="Left center right.")
    border = Aspect(docstring="Border around the component.")
    border_radius = Aspect(docstring="Round the corner of the component, needs a background or border.")  # noqa: E501
    cursor = Aspect(docstring="Cursor when the mouse is over the component.")
    flex_grow = Aspect(docstring="Grow factor for flex item.")
    flex_shrink = Aspect(docstring="Shrink factor for flex item.")
    align_self = Aspect(docstring="Flex alignment for the component. (Possible values: 'flex-start', 'flex-end', 'center', 'stretch', 'baseline', 'auto')")  # noqa: E501
    display = Aspect(docstring="CSS, How to display the component.")
    rounded = Aspect(docstring="Round the edge of the container with borderRadius: 3px;")  # noqa: E501
    bordered = Aspect(docstring="Apply default bordering with neutral dark grey,")  # noqa: E501
    centered = Aspect(docstring="Center the content in the middle of the container.")  # noqa: E501
    hidden = Aspect(docstring="Hide the component;")
    unselectable = Aspect(docstring="Do not allow for the text to be selected.")  # noqa: E501
    preset_color = Aspect(docstring="Preset color to apply to the font. (Possible values: 'primary', 'primary-light', 'primary-dark', 'secondary', 'secondary-light', 'secondary-dark', 'tertiary', 'tertiary-light', 'tertiary-dark', 'danger', 'danger-light', 'danger-dark', 'warning', 'warning-light', 'warning-dark', 'success', 'success-light', 'success-dark', 'neutral', 'neutral-light', 'neutral-dark', 'dark', 'dark-light', 'dark-dark', 'darker', 'darker-light', 'darker-dark')")  # noqa: E501
    preset_background = Aspect(docstring="Preset color to apply to the background. (Possible values: 'primary', 'primary-light', 'primary-dark', 'secondary', 'secondary-light', 'secondary-dark', 'tertiary', 'tertiary-light', 'tertiary-dark', 'danger', 'danger-light', 'danger-dark', 'warning', 'warning-light', 'warning-dark', 'success', 'success-light', 'success-dark', 'neutral', 'neutral-light', 'neutral-dark', 'dark', 'dark-light', 'dark-dark', 'darker', 'darker-light', 'darker-dark')")  # noqa: E501
    preset_size = Aspect(docstring="Scale the size of the container using a preset. (Possible values: 'tiny', 'small', 'medium', 'large', 'larger', 'x-large', 'xx-large')")  # noqa: E501
    class_name = Aspect(docstring="Class name automatically added by dazzler api with a prefix for the component library.ie: core component Container become ``dazzler-core-container``.When added on the component, the class names will be concatenated.")  # noqa: E501
    style = Aspect(docstring="Style object for the top level wrapper of the component.")  # noqa: E501

    def __init__(
            self,
            items: typing.Optional[typing.List[typing.Union[str, int, float, Component, typing.List[typing.Union[str, int, float, Component]]]]] = UNDEFINED,  # noqa: E501
            max_length: typing.Optional[typing.Union[float, int]] = UNDEFINED,
            append: typing.Optional[typing.Union[str, int, float, Component, typing.List[typing.Union[str, int, float, Component]]]] = UNDEFINED,  # noqa: E501
            prepend: typing.Optional[typing.Union[str, int, float, Component, typing.List[typing.Union[str, int, float, Component]]]] = UNDEFINED,  # noqa: E501
            concat: typing.Optional[typing.List[typing.Union[str, int, float, Component, typing.List[typing.Union[str, int, float, Component]]]]] = UNDEFINED,  # noqa: E501
            insert: typing.Optional[typing.Dict[str, typing.Union[typing.Union[float, int], typing.Union[str, int, float, Component, typing.List[typing.Union[str, int, float, Component]]]]]] = UNDEFINED,  # noqa: E501
            delete_index: typing.Optional[typing.Union[float, int]] = UNDEFINED,  # noqa: E501
            scrollable: typing.Optional[bool] = UNDEFINED,
            direction: typing.Optional[typing.Any] = "'vertical'",
            size: typing.Optional[typing.Union[float, int]] = UNDEFINED,
            keep_scroll: typing.Optional[bool] = UNDEFINED,
            color: typing.Optional[str] = UNDEFINED,
            background: typing.Optional[str] = UNDEFINED,
            padding: typing.Optional[typing.Union[str, typing.Union[float, int]]] = UNDEFINED,  # noqa: E501
            margin: typing.Optional[typing.Union[str, typing.Union[float, int]]] = UNDEFINED,  # noqa: E501
            overflow: typing.Optional[str] = UNDEFINED,
            height: typing.Optional[typing.Union[str, typing.Union[float, int]]] = UNDEFINED,  # noqa: E501
            max_height: typing.Optional[typing.Union[str, typing.Union[float, int]]] = UNDEFINED,  # noqa: E501
            width: typing.Optional[typing.Union[str, typing.Union[float, int]]] = UNDEFINED,  # noqa: E501
            max_width: typing.Optional[typing.Union[str, typing.Union[float, int]]] = UNDEFINED,  # noqa: E501
            font_family: typing.Optional[str] = UNDEFINED,
            font_size: typing.Optional[typing.Union[str, typing.Union[float, int]]] = UNDEFINED,  # noqa: E501
            font_weight: typing.Optional[typing.Union[str, typing.Union[float, int]]] = UNDEFINED,  # noqa: E501
            font_style: typing.Optional[str] = UNDEFINED,
            text_align: typing.Optional[str] = UNDEFINED,
            border: typing.Optional[str] = UNDEFINED,
            border_radius: typing.Optional[typing.Union[str, typing.Union[float, int]]] = UNDEFINED,  # noqa: E501
            cursor: typing.Optional[str] = UNDEFINED,
            flex_grow: typing.Optional[typing.Union[float, int]] = UNDEFINED,
            flex_shrink: typing.Optional[typing.Union[float, int]] = UNDEFINED,  # noqa: E501
            align_self: typing.Optional[typing.Any] = UNDEFINED,
            display: typing.Optional[str] = UNDEFINED,
            rounded: typing.Optional[bool] = UNDEFINED,
            bordered: typing.Optional[bool] = UNDEFINED,
            centered: typing.Optional[bool] = UNDEFINED,
            hidden: typing.Optional[bool] = UNDEFINED,
            unselectable: typing.Optional[bool] = UNDEFINED,
            preset_color: typing.Optional[typing.Any] = UNDEFINED,
            preset_background: typing.Optional[typing.Any] = UNDEFINED,
            preset_size: typing.Optional[typing.Any] = UNDEFINED,
            class_name: typing.Optional[str] = UNDEFINED,
            style: typing.Optional[typing.Dict] = UNDEFINED,
            identity: str = None
    ):
        """
        :param items: List of items to render. (default=[])
        :param max_length: Maximum amount of items in the list, extra items
            will be popped off.
        :param append: Add an item to the end of the list.
        :param prepend: Add an item to the start of the list.
        :param concat: Concatenate another list with the current items.
        :param insert: Insert an item at an index position.
        :param delete_index: Delete the item at the index.
        :param scrollable: Wether the list box container is scrollable.
            Set the overflow content to scroll.
        :param direction: In which direction the items will be inserted.
            (Possible values: 'vertical', 'horizontal') (default="'vertical'")
        :param size: Must be set for the scrollable aspect to work. Height
            or width in pixels depending on the direction aspect.
        :param keep_scroll: Keep the last appended item in view if
            scrolling is enabled.
        :param color: Font color
        :param background: Background color/image
        :param padding: Space around the content before the border
        :param margin: Space after the element border
        :param overflow: Overflow the content and show a scrollbar.
        :param height: Height of the component.
        :param max_height: Maximum height before overflow.
        :param width: Width of the component.
        :param max_width: Maximum width before overflowing.
        :param font_family: Font to use.
        :param font_size: Size of the font.
        :param font_weight: Boldness
        :param font_style: Italic
        :param text_align: Left center right.
        :param border: Border around the component.
        :param border_radius: Round the corner of the component, needs a
            background or border.
        :param cursor: Cursor when the mouse is over the component.
        :param flex_grow: Grow factor for flex item.
        :param flex_shrink: Shrink factor for flex item.
        :param align_self: Flex alignment for the component. (Possible
            values: 'flex-start', 'flex-end', 'center', 'stretch', 'baseline',
            'auto')
        :param display: CSS, How to display the component.
        :param rounded: Round the edge of the container with borderRadius:
            3px;
        :param bordered: Apply default bordering with neutral dark grey,
        :param centered: Center the content in the middle of the container.
        :param hidden: Hide the component;
        :param unselectable: Do not allow for the text to be selected.
        :param preset_color: Preset color to apply to the font. (Possible
            values: 'primary', 'primary-light', 'primary-dark', 'secondary',
            'secondary-light', 'secondary-dark', 'tertiary', 'tertiary-light',
            'tertiary-dark', 'danger', 'danger-light', 'danger-dark',
            'warning', 'warning-light', 'warning-dark', 'success', 'success-
            light', 'success-dark', 'neutral', 'neutral-light', 'neutral-dark',
            'dark', 'dark-light', 'dark-dark', 'darker', 'darker-light',
            'darker-dark')
        :param preset_background: Preset color to apply to the background.
            (Possible values: 'primary', 'primary-light', 'primary-dark',
            'secondary', 'secondary-light', 'secondary-dark', 'tertiary',
            'tertiary-light', 'tertiary-dark', 'danger', 'danger-light',
            'danger-dark', 'warning', 'warning-light', 'warning-dark',
            'success', 'success-light', 'success-dark', 'neutral', 'neutral-
            light', 'neutral-dark', 'dark', 'dark-light', 'dark-dark',
            'darker', 'darker-light', 'darker-dark')
        :param preset_size: Scale the size of the container using a preset.
            (Possible values: 'tiny', 'small', 'medium', 'large', 'larger',
            'x-large', 'xx-large')
        :param class_name: Class name automatically added by dazzler api
            with a prefix for the  component library. ie: core component
            Container become ``dazzler-core-container``. When added on the
            component, the class names will be concatenated.
        :param style: Style object for the top level wrapper of the
            component.
        """
        Component.__init__(self, locals(), identity)
