"""Autogenerated file: DO NOT EDIT!"""
import typing  # noqa: F401
from dazzler.system import Component, Aspect, UNDEFINED  # noqa: F401


class Switch(Component):
    """
    On/Off switch.

    :CSS:

        - ``dazzler-core-switch``
        - ``switch-on``
        - ``switch-off``
        - ``switch-caret``

    :example:

    .. literalinclude:: ../../tests/components/pages/switch.py
    """
    value = Aspect(docstring="Switched on or off")
    disabled = Aspect(docstring="Disabled the switch from being toggled.")
    rounded = Aspect(default=True, docstring="Round the edge of the switch. (default=True)")  # noqa: E501
    preset_color = Aspect(docstring="Color of the switch (Possible values: 'primary', 'primary-light', 'primary-dark', 'secondary', 'secondary-light', 'secondary-dark', 'tertiary', 'tertiary-light', 'tertiary-dark', 'danger', 'danger-light', 'danger-dark', 'warning', 'warning-light', 'warning-dark', 'success', 'success-light', 'success-dark', 'neutral', 'neutral-light', 'neutral-dark', 'dark', 'dark-light', 'dark-dark', 'darker', 'darker-light', 'darker-dark')")  # noqa: E501
    preset_size = Aspect(docstring="(Possible values: 'tiny', 'small', 'medium', 'large', 'larger', 'x-large', 'xx-large')")  # noqa: E501
    color = Aspect(docstring="Font color")
    background = Aspect(docstring="Background color/image")
    padding = Aspect(docstring="Space around the content before the border")
    margin = Aspect(docstring="Space after the element border")
    overflow = Aspect(docstring="Overflow the content and show a scrollbar.")
    height = Aspect(docstring="Height of the component.")
    max_height = Aspect(docstring="Maximum height before overflow.")
    width = Aspect(docstring="Width of the component.")
    max_width = Aspect(docstring="Maximum width before overflowing.")
    font_family = Aspect(docstring="Font to use.")
    font_size = Aspect(docstring="Size of the font.")
    font_weight = Aspect(docstring="Boldness")
    font_style = Aspect(docstring="Italic")
    text_align = Aspect(docstring="Left center right.")
    border = Aspect(docstring="Border around the component.")
    border_radius = Aspect(docstring="Round the corner of the component, needs a background or border.")  # noqa: E501
    cursor = Aspect(docstring="Cursor when the mouse is over the component.")
    flex_grow = Aspect(docstring="Grow factor for flex item.")
    flex_shrink = Aspect(docstring="Shrink factor for flex item.")
    align_self = Aspect(docstring="Flex alignment for the component. (Possible values: 'flex-start', 'flex-end', 'center', 'stretch', 'baseline', 'auto')")  # noqa: E501
    display = Aspect(docstring="CSS, How to display the component.")
    class_name = Aspect(docstring="Class name automatically added by dazzler api with a prefix for the component library.ie: core component Container become ``dazzler-core-container``.When added on the component, the class names will be concatenated.")  # noqa: E501
    style = Aspect(docstring="Style object for the top level wrapper of the component.")  # noqa: E501

    def __init__(
            self,
            value: typing.Optional[bool] = UNDEFINED,
            disabled: typing.Optional[bool] = UNDEFINED,
            rounded: typing.Optional[bool] = True,
            preset_color: typing.Optional[typing.Any] = UNDEFINED,
            preset_size: typing.Optional[typing.Any] = UNDEFINED,
            color: typing.Optional[str] = UNDEFINED,
            background: typing.Optional[str] = UNDEFINED,
            padding: typing.Optional[typing.Union[str, typing.Union[float, int]]] = UNDEFINED,  # noqa: E501
            margin: typing.Optional[typing.Union[str, typing.Union[float, int]]] = UNDEFINED,  # noqa: E501
            overflow: typing.Optional[str] = UNDEFINED,
            height: typing.Optional[typing.Union[str, typing.Union[float, int]]] = UNDEFINED,  # noqa: E501
            max_height: typing.Optional[typing.Union[str, typing.Union[float, int]]] = UNDEFINED,  # noqa: E501
            width: typing.Optional[typing.Union[str, typing.Union[float, int]]] = UNDEFINED,  # noqa: E501
            max_width: typing.Optional[typing.Union[str, typing.Union[float, int]]] = UNDEFINED,  # noqa: E501
            font_family: typing.Optional[str] = UNDEFINED,
            font_size: typing.Optional[typing.Union[str, typing.Union[float, int]]] = UNDEFINED,  # noqa: E501
            font_weight: typing.Optional[typing.Union[str, typing.Union[float, int]]] = UNDEFINED,  # noqa: E501
            font_style: typing.Optional[str] = UNDEFINED,
            text_align: typing.Optional[str] = UNDEFINED,
            border: typing.Optional[str] = UNDEFINED,
            border_radius: typing.Optional[typing.Union[str, typing.Union[float, int]]] = UNDEFINED,  # noqa: E501
            cursor: typing.Optional[str] = UNDEFINED,
            flex_grow: typing.Optional[typing.Union[float, int]] = UNDEFINED,
            flex_shrink: typing.Optional[typing.Union[float, int]] = UNDEFINED,  # noqa: E501
            align_self: typing.Optional[typing.Any] = UNDEFINED,
            display: typing.Optional[str] = UNDEFINED,
            class_name: typing.Optional[str] = UNDEFINED,
            style: typing.Optional[typing.Dict] = UNDEFINED,
            identity: str = None
    ):
        """
        :param value: Switched on or off
        :param disabled: Disabled the switch from being toggled.
        :param rounded: Round the edge of the switch. (default=True)
        :param preset_color: Color of the switch (Possible values:
            'primary', 'primary-light', 'primary-dark', 'secondary',
            'secondary-light', 'secondary-dark', 'tertiary', 'tertiary-light',
            'tertiary-dark', 'danger', 'danger-light', 'danger-dark',
            'warning', 'warning-light', 'warning-dark', 'success', 'success-
            light', 'success-dark', 'neutral', 'neutral-light', 'neutral-dark',
            'dark', 'dark-light', 'dark-dark', 'darker', 'darker-light',
            'darker-dark')
        :param preset_size: (Possible values: 'tiny', 'small', 'medium',
            'large', 'larger', 'x-large', 'xx-large')
        :param color: Font color
        :param background: Background color/image
        :param padding: Space around the content before the border
        :param margin: Space after the element border
        :param overflow: Overflow the content and show a scrollbar.
        :param height: Height of the component.
        :param max_height: Maximum height before overflow.
        :param width: Width of the component.
        :param max_width: Maximum width before overflowing.
        :param font_family: Font to use.
        :param font_size: Size of the font.
        :param font_weight: Boldness
        :param font_style: Italic
        :param text_align: Left center right.
        :param border: Border around the component.
        :param border_radius: Round the corner of the component, needs a
            background or border.
        :param cursor: Cursor when the mouse is over the component.
        :param flex_grow: Grow factor for flex item.
        :param flex_shrink: Shrink factor for flex item.
        :param align_self: Flex alignment for the component. (Possible
            values: 'flex-start', 'flex-end', 'center', 'stretch', 'baseline',
            'auto')
        :param display: CSS, How to display the component.
        :param class_name: Class name automatically added by dazzler api
            with a prefix for the  component library. ie: core component
            Container become ``dazzler-core-container``. When added on the
            component, the class names will be concatenated.
        :param style: Style object for the top level wrapper of the
            component.
        """
        Component.__init__(self, locals(), identity)
